"Filed out from Dolphin Smalltalk 99 release 3.0"!

DarkLocation subclass: #HallOfMountainKing
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''!

HallOfMountainKing class instanceVariableNames: ''!

HallOfMountainKing comment: ''!

HallOfMountainKing guid: (GUID fromString: '{B1FE94BD-54A3-11D3-8268-00001D19F5C2}')!

!HallOfMountainKing categoriesForClass!No category! !

!HallOfMountainKing methodsFor!

add: anObject
	"If the bird is dropped and the snake is present we remove the snake and
	provide a nice little message"

	| response |

	response := super add: anObject.

	self world notNil ifTrue: [
		(anObject = self world bird) & (self contains: self world snake)
			ifTrue: [
				self remove: self world snake.
				^Response text: 'The little bird attacks the green snake, and in an ',
							'astounding flurry drives the snake away.' ] ].
	^response!

allowTravelBy: anActor through: aConnection
	"If the snake is present the adventurer can't go in certain directions"

	(self contains: anActor world snake)
		ifTrue: [ #('north' 'left' 'south' 'right' 'west' 'forward') do: [ :each |
				(aConnection hasSynonym: each) ifTrue: [ ^false ] ] ].
	^true!

travelFailureReasonFor: anActor through: aConnection
	(self contains: anActor world snake)
		ifTrue: [ #('north' 'left' 'south' 'right' 'west' 'forward') do: [ :each |
				(aConnection hasSynonym: each) ifTrue: [ ^'You can''t get past the snake' ] ] ]
		ifFalse: [ ^'' ]! !

!HallOfMountainKing categoriesFor: #add:!*-unclassified!public! !
!HallOfMountainKing categoriesFor: #allowTravelBy:through:!*-unclassified!public! !
!HallOfMountainKing categoriesFor: #travelFailureReasonFor:through:!*-unclassified!public! !

