"Filed out from Dolphin Smalltalk 99 release 3.0"!

ImmovableItem subclass: #Plant
	instanceVariableNames: 'state'
	classVariableNames: ''
	poolDictionaries: ''!

Plant class instanceVariableNames: ''!

Plant comment: ''!

Plant guid: (GUID fromString: '{B1FE94B9-54A3-11D3-8268-00001D19F5C2}')!

!Plant categoriesForClass!No category! !

!Plant methodsFor!

basicDescription
	^self longDescription!

basicLongDescription
	^self longDescription!

incrementState
	self state = 1 ifTrue: [
		self state: 2.
		^'The plant spurts into furious growth for a few seconds.' ].
	self state = 2 ifTrue: [
		self state: 3.
		^'The plant grows explosively, almost filling the bottom of the pit.' ].
	self state = 3 ifTrue: [
		self state: 1.
		^'You''ve over-watered the plant!!  It''s shriveling up!! It''s, It''s...' ]!

initialize
	super initialize.
	self state: 1!

longDescription
	self state = 1 ifTrue: [ ^'There is a tiny little plant in the pit, murmuring "Water, Water, ..."' ].
	self state = 2 ifTrue: [ ^'There is a 12-foot-tall beanstalk stretching up out of the pit, bellowing "Water!!!! Water!!!!"' ].
	self state = 3 ifTrue: [ ^'There is a gigantic beanstalk stretching all the way up to the hole.' ]!

state
	"Private"
	^state!

state: anObject
	"Private"

	state := anObject! !

!Plant categoriesFor: #basicDescription!*-unclassified!public! !
!Plant categoriesFor: #basicLongDescription!*-unclassified!public! !
!Plant categoriesFor: #incrementState!*-unclassified!public! !
!Plant categoriesFor: #initialize!*-unclassified!public! !
!Plant categoriesFor: #longDescription!*-unclassified!public! !
!Plant categoriesFor: #state!accessing!public! !
!Plant categoriesFor: #state:!accessing!public! !

